﻿namespace SCOM
{

    using System;
    using System.Text;
    using System.IO.Ports;
    using System.Windows.Forms;

    public partial class Form1 : Form
    {

        private static SerialPort serialPort;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            // Some Date to Sendto your MCU:
            string txData = "Transmit me to your MCU<EOS>";

            // Display the Data:
            TXTextBox.Text = txData;

            // Initialise a new Serial Port:
            serialPort = new SerialPort();

            // Atach an Event Handler for Data Received:
            serialPort.DataReceived += new SerialDataReceivedEventHandler(serialDataReceived);

            // Configure the Serial Port to match settings on your MCU:
            serialPort.BaudRate = 9600;
            serialPort.DataBits = 8;
            serialPort.Parity = Parity.None;
            serialPort.PortName = "<PUT YOUR COM PORT HERE>"; // Dont forget this!!!
            serialPort.StopBits = StopBits.One;

            // For Testing:
            serialPort.PortName = "COM1";

            // Open Serial Ports and disable Buttons....
            serialPort.Open();
        }

        private void SendButton_Click(object sender, EventArgs e)
        {

            // Make sure the Port is Open:
            if (serialPort.IsOpen)
                if (TXTextBox.Text.Length > 0)
                {

                    // Convert and fill the Teext to a Byte Array:
                    byte[] txBuffer = Encoding.UTF8.GetBytes(TXTextBox.Text);

                    // Write the Buffer to the Serial Port:
                    serialPort.Write(txBuffer, 0, txBuffer.Length);

                }

        }

        private void serialDataReceived(object sender, SerialDataReceivedEventArgs e)
        {

            try
            {

                // Read the Received Byte Array and Convert to String:
                string rxString = serialPort.ReadLine();

                // Display String:
                Invoke(new Action(() => { RXTextBox.Text = rxString; }));
            }
            catch (System.IO.IOException iOEX)
            {

                // Catch Exception:
            }
            catch (System.TimeoutException timEX)
            {

                // Catch Exception:
            }
        }
    }
}
